<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 08/14/2004 *
 * ================                             Last change: 10/22/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-admins_mails.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Control which admin shall receive which mail     *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Stellen Sie ein, welcher Admin welche Mail erh.  *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
}

// Add description as navigation point
addMenuDescription('admin', __FILE__);

if (isPostRequestElementSet('edit')) {
	// Check if entires are checked
	$SEL = countPostSelection();
	if ($SEL > 0) {
		// Add option for events
		$adminsList = generateOptionList('admins', 'id', 'login', '', 'email');
		$SW = 2; $rowNameS = '';
		foreach (postRequestElement('sel') as $template => $sel) {
			// First of all load data from DB
			$result = SQL_QUERY_ESC("SELECT `admin_id`, `id` FROM `{?_MYSQL_PREFIX?}_admins_mails` WHERE `mail_template`='%s' ORDER BY `id` ASC",
				array($template), __FILE__, __LINE__);
			$OUT = ''; $adminId2 = 0;
			while ($content = SQL_FETCHARRAY($result)) {
				// @TODO Can this be rewritten???
				$OUT .= "<select name=\"admin_id[".$content['id']."]\" size=\"1\" class=\"admin_select\">
<option value=\"0\"";
				if ($content['admin_id'] == 0) $OUT .= ' selected="selected"';
				$OUT .=">{--ADMINS_ALL_ADMINS--}</option>\n";
				if (isExtensionActive('events')) {
					$OUT .= "<option value=\"-1\"";
					if ($content['admin_id'] == '-1') $OUT .= ' selected="selected"';
					$OUT .= ">{--ADMINS_TO_USER_EVENTS--}</option>\n";
				}
				$OUT .= generateOptionList('admins', 'id', 'login', $content['admin_id'], 'email');
				$OUT .= "</select>\n<br />\n";
				$adminId2 = $content['admin_id']; $id2 = $content['id'];
			}

			// Free memory
			SQL_FREERESULT($result);

			// Prepare content
			$content = array(
				'sw'      => $SW,
				'id'      => $id,
				'id2'     => $id2,
				'tpl'     => $template,
				'admins'  => $adminsList
			);

			if ($adminId2 > 0) {
				// Add form for an additional admin
				$OUT .= loadTemplate('admin_admins_mails_edit_form', true, $content);
			} // END - if

			// Save full rendered content
			$content['content'] = $OUT;

			// Start outputing line
			$rowNameS .= loadTemplate('admin_admins_mails_edit_row', true, $content);
			$SW = 3 - $SW;
		}

		// Edit checked entries
		loadTemplate('admin_admins_mails_edit', false, $rowNameS);
	} else {
		// Nothing selected
		loadTemplate('admin_settings_saved', false, getMessage('ADMINS_NO_MAIL_CHECKED'));
	}
} else {
	// Load all assigned mails
	$result = SQL_QUERY("SELECT
	m.id, m.admin_id, a.login, m.mail_template
FROM
	`{?_MYSQL_PREFIX?}_admins_mails` AS m
LEFT JOIN
	`{?_MYSQL_PREFIX?}_admins` AS a
ON
	m.admin_id=a.id
WHERE
	(m.admin_id=a.id OR m.admin_id < 1) AND m.mail_template != ''
ORDER BY
	m.admin_id ASC,
	m.mail_template ASC", __FILE__, __LINE__);

	if (SQL_NUMROWS($result) > 0) {
		// Shall I change entries?
		if (isPostRequestElementSet('change')) {
			// Init SQLs
			initSqls();

			// Ok, update database
			foreach (postRequestElement('admin_id') as $id => $content['admin_id']) {
				// Secure ids
				$id  = bigintval($id);
				$content['admin_id'] = bigintval($content['admin_id']);

				// Update entry
				addSql(SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_admins_mails` SET admin_id=%s WHERE `id`=%s ORDER BY `id` LIMIT 1",
				array($content['admin_id'], $id), __FILE__, __LINE__, false));

				if (($content['admin_id'] < 1) && (isPostRequestElementSet('template', $id))) {
					// Remove any other admin entries
					addSql(SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_admins_mails` WHERE mail_template='%s' AND id != '%s'",
					array(postRequestElement('template', $id), $id), __FILE__, __LINE__, false));
				} // END - if

				if (postRequestElement('admin_new', postRequestElement('template', $id)) > 0) {
					// Add new admin
					addSql(SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_admins_mails` (admin_id, mail_template) VALUES ('%s','%s')",
					array($content['admin_id'], postRequestElement('template', $id)), __FILE__, __LINE__, false));
				} // END - if
			} // END - foreach

			// Run all queries
			runFilterChain('run_sqls');

			// Query again...
			$result = SQL_QUERY("SELECT m.id, m.admin_id, a.login, m.mail_template FROM `{?_MYSQL_PREFIX?}_admins_mails` AS m, `{?_MYSQL_PREFIX?}_admins` AS a WHERE m.admin_id=a.id OR m.admin_id < 1 ORDER BY m.admin_id", __FILE__, __LINE__);
		} // END - if

		// List found entries
		$OUT = ''; $SW = 2;
		while ($data = SQL_FETCHARRAY($result)) {
			// Prepare content
			$content = array(
				'sw'   => $SW,
				'id'   => $data['id'],
				'tpl'  => $data['mail_template'],
				'alnk' => generateAdminLink($data['admin_id'])
			);

			// Load row template
			$OUT .= loadTemplate('admin_admins_mails_list_row', true, $content);
			$SW = 3 - $SW;
		} // END - while

		// Free result
		SQL_FREERESULT($result);

		// Load template
		loadTemplate('admin_admins_mails_list', false, $OUT);
	} else {
		// No entries found
		loadTemplate('admin_settings_saved', false, getMessage('ADMINS_MAILS_NO_ENTRIES'));
	}
}

// [EOF]
?>
