<?php
/************************************************************************
 * M-XChange v0.2.1                                   Start: 04/25/2005 *
 * ================                             Last change: 05/19/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-list_sponsor.php                            *
 * -------------------------------------------------------------------- *
 * Short description : List all sponsors and their details              *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Alle Sponsoren und deren Details auflisten       *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
}

// Add description as navigation point
addMenuDescription('admin', __FILE__);

if (isGetRequestElementSet('id')) {
	// Show detailed informations to a sponsor
	$result = SQL_QUERY_ESC("SELECT company, position, gender, surname, family, street_nr1, street_nr2, zip, city, country, phone, fax, cell, email, url, tax_ident, status, sponsor_created, last_online, last_change, receive_warnings, points_amount, points_used, remote_addr, warning_interval, refid, ref_count
FROM `{?_MYSQL_PREFIX?}_sponsor_data`
WHERE `id`='%s' LIMIT 1",
	array(bigintval(getRequestElement('id'))), __FILE__, __LINE__);

	if (SQL_NUMROWS($result) == 1) {
		// Load sponsor details
		$content = SQL_FETCHARRAY($result);
		SQL_FREERESULT($result);

		// Check if an entry is empty
		foreach ($content as $k => $v) {
			if (empty($v)) $content[$k] = '---';
		}

		// Check for sponsor's orders (only count)
		$result_orders = SQL_QUERY_ESC("SELECT COUNT(id) FROM `{?_MYSQL_PREFIX?}_sponsor_orders` WHERE sponsorid='%s'",
		array(bigintval(getRequestElement('id'))), __FILE__, __LINE__);
		list($orders) = SQL_FETCHROW($result_orders);
		SQL_FREERESULT($result_orders);
		if (empty($orders)) $orders = 0;

		// Prepare all data for the template
		//  Sponsor's id
		$content['id']                = getRequestElement('id');
		//  Personal data
		$content['gender']      = translateGender($content['gender']);
		//  Contact data
		$content['email_link']  = generateEmailLink($content['email'], 'sponsor_data');
		$content['url']         = generateDerefererUrl($content['url']);
		//  Timestamps
		$content['created']     = generateDateTime($content['sponsor_created'], 2);
		$content['last_online'] = generateDateTime($content['last_online'], 2);
		$content['last_change'] = generateDateTime($content['last_change'], 2);
		//  Sponsor points
		$content['points_amount'] = translateComma($content['points_amount']);
		$content['points_used']   = translateComma($content['points_used']);
		//  Warning because low points
		$content['receive_warnings'] = translateYesNo($content['receive_warnings']);
		$content['warning_interval'] = createFancyTime($content['warning_interval']);
		//  Orders total
		$content['orders']           = $orders;
		//  Other data
		$content['status']           = sponsorTranslateUserStatus($content['status']);

		// Load template
		loadTemplate('admin_list_sponsor_details', false, $content);
	} else {
		// Sponsor not found
		loadTemplate('admin_settings_saved', false, sprintf(getMessage('ADMIN_SPONSOR_404'), getRequestElement('id')));
	}
} elseif (isGetRequestElementSet('rid')) {
	// Search for sponsor
	$result = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_sponsor_data` WHERE `id`='%s' LIMIT 1",
		array(bigintval(getRequestElement('rid'))), __FILE__, __LINE__);
	if (SQL_NUMROWS($result) == 1) {
		// Free memory
		SQL_FREERESULT($result);

		// Sponsor found so let's list all his referals
		$result = SQL_QUERY_ESC("SELECT
	`id`, `gender`, `surname`, `family`, `email`, `status`,
	`sponsor_created`, `last_online`, `points_amount`, `points_used`,
	`remote_addr`, `ref_count`
FROM
	`{?_MYSQL_PREFIX?}_sponsor_data`
WHERE
	`refid`='%s'
ORDER BY
	`id` ASC",
		array(bigintval(getRequestElement('rid'))), __FILE__, __LINE__);

		if (SQL_NUMROWS($result) > 0) {
			// List refs now
			// Free memory
			SQL_FREERESULT($result);
		} else {
			// No refs made so far
			loadTemplate('admin_settings_saved', false, sprintf(getMessage('ADMIN_SPONSOR_REFS_404'), "<a href=\"{?URL?}/modules.php?module=admin&amp;what=list_sponsor&amp;id=".bigintval(getRequestElement('rid'))."\">".bigintval(getRequestElement('rid'))."</a>"));
		}
	} else {
		// Sponsor not found
		loadTemplate('admin_settings_saved', false, sprintf(getMessage('ADMIN_SPONSOR_404'), bigintval(getRequestElement('rid'))));
	}
} else {
	// List all sponsors
	$result_main = SQL_QUERY("SELECT
	`id`, `gender`, `surname`, `family`, `email`, `status`,
	`sponsor_created`, `last_online`, `points_amount`, `points_used`, `remote_addr`
FROM
	`{?_MYSQL_PREFIX?}_sponsor_data`
ORDER BY
	`id` ASC", __FILE__, __LINE__);

	if (SQL_NUMROWS($result_main) > 0) {
		// At least one sponsor found!
		$OUT = ''; $SW = 2;
		while ($content = SQL_FETCHARRAY($result_main)) {
			// Transfer data to array
			// @TODO Rewritings: surname->surname,family->family,ip->remote_addr in template
			$content = array(
				'id'      => $content['id'],
				'sw'      => $SW,
				'gender'  => translateGender($content['gender']),
				'surname'   => $content['surname'],
				'family'   => $content['family'],
				'email'   => generateEmailLink($content['email'], 'sponsor_data'),
				'status'  => sponsorTranslateUserStatus($content['status']),
				'created' => generateDateTime($content['sponsor_created'], 2),
				'last_online'    => generateDateTime($content['last_online'], 2),
				'points'  => translateComma($content['points_amount'] - $content['points_used']),
				'ip'      => $content['remote_addr'],
			);

			// Load row template
			$OUT .= loadTemplate('admin_list_sponsor_row', true, $content);
			$SW = 3 - $SW;
		}

		// Free memory
		SQL_FREERESULT($result_main);

		// Load final template
		loadTemplate('admin_list_sponsor', false, $OUT);
	} else {
		// No sponsors registered so far
		loadTemplate('admin_settings_saved', false, getMessage('ADMIN_SPONSOR_NONE_REGISTERED'));
	}
}

// [EOF]
?>
