<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 10/16/2003 *
 * ===============                              Last change: 06/30/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-mydata.php                                  *
 * -------------------------------------------------------------------- *
 * Short description : Members can edit their profile data here         *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Mitglieder koennen hier ihre Profildaten aendern *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} elseif (!isMember()) {
	redirectToIndexMemberOnlyModule();
}

// Add description as navigation point
addMenuDescription('member', __FILE__);

if ((!isExtensionActive('mydata')) && (!isAdmin())) {
	loadTemplate('admin_settings_saved', false, generateExtensionInactiveNotInstalledMessage('mydata'));
	return;
} // END - if

// Add userid
$content = array(
	'userid' => getUserId()
);

// Init variable to prevent notices
$URL = '';

// Detect what the member wants to do
$mode = 'show'; // Show his data
if (isPostRequestElementSet('save'))   $mode = 'save';   // Save entered data
if (isPostRequestElementSet('edit'))   $mode = 'edit';   // Edit data
if (isPostRequestElementSet('notify')) $mode = 'notify'; // Switch off notification

switch ($mode) {
	case 'show': // Show his data
		// Get user data
		if (!fetchUserData(getUserId())) {
			// Something really bad happended
			debug_report_bug('No user account ' . getUserId() . ' found.');
		} // END - if

		// Get line
		$content = merge_array($content, getUserDataArray());

		// Translate some things
		$content['gender']      = translateGender($content['gender']);
		$content['last_update'] = generateDateTime($content['last_update'], 0);

		// How far is last change on his profile away from now?
		if ((($content['last_update'] + getConfig('profile_lock')) > time()) && (!isAdmin()) && (getConfig('profile_lock') > 0)) {
			// You cannot change your account
			$content['change'] = loadTemplate('admin_settings_saved', true, "<div class=\"member_failed\">".sprintf(getMessage('MEMBER_PROFILE_LOCKED'), generateDateTime($content['last_update'] + getConfig('profile_lock'), 0))."</div>");
		} else {
			// He is allowed to change his profile
			$content['change'] = loadTemplate('member_mydata_button', true);
		}

		if (strlen($content['birth_day'])   == 1) $content['birth_day']   = 0 . $content['birth_day'];
		if (strlen($content['birth_month']) == 1) $content['birth_month'] = 0 . $content['birth_month'];

		switch (getLanguage()) {
			case 'de': $content['dob'] = $content['birth_day']   . '.' . $content['birth_month'] . '.' . $content['birth_year']; break;
			default  : $content['dob'] = $content['birth_month'] . '-' . $content['birth_day']   . '-' . $content['birth_year']; break;
		} // END - switch

		if (isExtensionActive('country')) {
			// Load country's description and code
			$content['country'] = generateCountryInfo($content['country_code']);
		} // END - if

		// Load template
		loadTemplate('member_mydata_overview', false, $content);
		break;

	case 'edit': // Edit data
		if (isExtensionActive('country', true)) {
			// New way                          0          1            2             3         4       5       6           7            8              9          10         11               12            13
			$result = SQL_QUERY_ESC("SELECT `surname`, `family`, `street_nr`, `country_code`, `zip`, `city`, `email`, `birth_day`, `birth_month`, `birth_year`, `gender`, `max_mails`, `receive_mails`, `last_update`
FROM
	`{?_MYSQL_PREFIX?}_user_data`
WHERE
	`userid`=%s
LIMIT 1",
			array(getUserId()), __FILE__, __LINE__);
		} else {
			// Old way                          0          1            2          3       4       5       6           7            8              9          10         11               12            13
			$result = SQL_QUERY_ESC("SELECT `surname`, `family`, `street_nr`, `country`, `zip`, `city`, `email`, `birth_day`, `birth_month`, `birth_year`, `gender`, `max_mails`, `receive_mails`, `last_update`
FROM
	`{?_MYSQL_PREFIX?}_user_data`
WHERE
	`userid`=%s
LIMIT 1",
				array(getUserId()), __FILE__, __LINE__);
		}

		// Get line
		$content = merge_array($content, SQL_FETCHARRAY($result, 0, false));

		// Free result
		SQL_FREERESULT($result);

		$content['update_check'] = $content['last_update'] + getConfig('profile_lock');

		// How far is last change on his profile away from now?
		if (($content['update_check'] > time()) && (!isAdmin()) && (getConfig('profile_lock') > 0)) {
			$content['update_check'] = sprintf(getMessage('MEMBER_PROFILE_LOCKED'), generateDateTime($content['update_check'] + getConfig('profile_lock'), 0));

			// You cannot change your account
			loadTemplate('member_mydata_locked', false, $content);
		} else {
			// He is allowed to change his profile
			foreach (array('gender_m','gender_f','gender_c') as $entry) {
				$content[$entry] = '';
			} // END - foreach

			$content['gender_' . strtolower($content['gender'])] = ' selected="selected"';
			$content['dob'] = '';

			switch (getLanguage()) {
				case 'de': // German date format
					// Day
					$content['dob'] .= addSelectionBox('day', $content['birth_day']);

					// Month
					$content['dob'] .= addSelectionBox('month', $content['birth_month']);

					// Year
					$content['dob'] .= addSelectionBox('year', $content['birth_year']);
					break;

				default: // Default is the US date format... :)
					// Month
					$content['dob'] .= addSelectionBox('month', $content['birth_month']);

					// Day
					$content['dob'] .= addSelectionBox('day', $content['birth_day']);

					// Year
					$content['dob'] .= addSelectionBox('year', $content['birth_year']);
					break;
			} // END - if

			$content['max_receive_list'] = addMaxReceiveList('member', $content['max_mails'], true);

			if (isExtensionActive('country')) {
				// Generate selection box
				$OUT  = "<select name=\"country_code\" class=\"member_select\" size=\"1\">\n";
				$whereStatement = "WHERE `is_active`='Y'";
				if (isAdmin()) $whereStatement = '';
				$OUT .= generateOptionList('countries', 'id', 'descr', $content['country_code'], 'code', $whereStatement);
				$OUT .= "</select>";
				$content['country'] = $OUT;
			} else {
				// Ouput default input box
				$content['country'] = "<input type=\"text\" name=\"cntry\" class=\"member_normal\" size=\"2\" maxlength=\"3\" value=\"".$content['country']."\" />";
			}

			// Load template
			loadTemplate('member_mydata_edit', false, $content);
		}
		break;

	case 'save': // Save entered data
		// Load old email / password
		if (!fetchUserData(getUserId())) {
			// Something really bad happened
			debug_report_bug('No user account ' . getUserId() . ' found.');
		} // END - if

		// Get line
		$content = merge_array($content, getUserDataArray());

		// Calculate time to check
		$content['update_check'] = $content['last_update'] + getConfig('profile_lock');

		// How far is last change on his profile away from now?
		if (($content['update_check'] > time()) && (!isAdmin()) && (getConfig('profile_lock') > 0)) {
			$content['update_check'] = generateDateTime($content['update_check'] + getConfig('profile_lock'), 0);
			// You cannot change your account
			loadTemplate('member_mydata_locked', false, $content);
		} elseif ((!isEmailValid(postRequestElement('email'))) && (!isAdmin())) {
			// Invalid email address!
			loadTemplate('admin_settings_saved', false, getMessage('INVALID_EMAIL_ADDRESS_ENTERED'));
		} else {
			// Generate hash
			$hash = generateHash(postRequestElement('pass1'), substr($content['password'], 0, -40));
			if ((($hash == $content['password']) || (postRequestElement('pass1') == postRequestElement('pass2'))) && (isPostRequestElementSet('pass1'))) {
				// Only on simple changes normal mode is active = no email or password changed
				$mode = 'normal'; $AND = '';

				// Did the user changed the password?
				if ($hash != $content['password']) { $AND = ", `password`='".$hash."'"; $mode = 'pass'; }

				// Or did he changed his password?
				if (postRequestElement('email') != $content['email']) {
					// Jupp
					if ($mode == 'normal') {
						$mode = 'email';
					} else {
						$mode .= ';email';
					}
					setRequestPostElement('old_email', $content['email']);
				} // END - if

				// Update member's profile
				if (isExtensionActive('country')) {
					// New way
					SQL_QUERY_ESC("UPDATE
	`{?_MYSQL_PREFIX?}_user_data`
SET
	`gender`='%s', `surname`='%s', `family`='%s',
	`street_nr`='%s',
	`country_code`=%s, `zip`=%s, `city`='%s',
	`email`='%s',
	`birth_day`=%s, `birth_month`=%s, `birth_year`=%s,
	`max_mails`='%s',
	`last_update`=UNIX_TIMESTAMP()".$AND.",
	`notified`='N',
	`last_profile_sent`=UNIX_TIMESTAMP()
WHERE
	`userid`=%s
LIMIT 1",
						array(
							postRequestElement('gender'),
							postRequestElement('surname'),
							postRequestElement('family'),
							postRequestElement('street_nr'),
							bigintval(postRequestElement('country_code')),
							bigintval(postRequestElement('zip')),
							postRequestElement('city'),
							postRequestElement('email'),
							bigintval(postRequestElement('day')),
							bigintval(postRequestElement('month')),
							bigintval(postRequestElement('year')),
							bigintval(postRequestElement('max_mails')),
							getUserId()
						), __FILE__, __LINE__);
				} else {
					// Old way
					SQL_QUERY_ESC("UPDATE
	`{?_MYSQL_PREFIX?}_user_data`
SET
	`gender`='%s', `surname`='%s', `family`='%s',
	`street_nr`='%s',
	`country`='%s', `zip`=%s, `city`='%s',
	`email`='%s',
	`birth_day`=%s, `birth_month`=%s, `birth_year`=%s,
	`max_mails`='%s',
	`last_update`=UNIX_TIMESTAMP()".$AND.",
	`notified`='N',
	`last_profile_sent`=UNIX_TIMESTAMP()
WHERE
	`userid`=%s
LIMIT 1",
						array(
							postRequestElement('gender'),
							postRequestElement('surname'),
							postRequestElement('family'),
							postRequestElement('street_nr'),
							postRequestElement('cntry'),
							bigintval(postRequestElement('zip')),
							postRequestElement('city'),
							postRequestElement('email'),
							bigintval(postRequestElement('day')),
							bigintval(postRequestElement('month')),
							bigintval(postRequestElement('year')),
							bigintval(postRequestElement('max_mails')),
							getUserId()
						), __FILE__, __LINE__);
				}

				// Did something change?
				if (SQL_AFFECTEDROWS() == 1) {
					// Get all modes ...
					$modes = explode(';', $mode);

					// ... and run them through
					sendModeMails ('mydata', $modes);
				} else {
					// Something went wrong
					loadTemplate('admin_settings_saved', false, getMessage('MEMBER_UPDATE_FAILED'));
				}
			} else {
				// Entered wrong pass for updating profile
				loadTemplate('admin_settings_saved', false, getMessage('MEBER_UPDATE_PWD_WRONG'));
			}
		}
		break;

	case 'notify': // Switch off notfication
		SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `notified`='N', `last_update`=UNIX_TIMESTAMP() WHERE `userid`=%s LIMIT 1",
			array(getUserId()), __FILE__, __LINE__);
		$URL = 'modules.php?module=login&amp;what=welcome&amp;code=' . urlencode(getMessage('PROFILE_UPDATED'));
		break;
} // END - switch

if (!empty($URL)) {
	// Load generated URL
	redirectToUrl($URL);
} // END - if

// [EOF]
?>
